import mixer.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class Dynamic extends HttpServlet{
	
	File file = null;
	
	private static String htmlDynamic = null;
	
	//Lser in html-dokumentet till strngen htmlDynamic vid initieringen
	public void init() throws ServletException{
		if (htmlDynamic == null) {
			htmlDynamic = Mixer.getContent(new File(getServletContext().getRealPath("Dynamic.html")));
		}
	}

	/*Skapar ny mixer av strngen och erstter alla mix-strngar med dynamiskt framtagna miljvariabler
	 * det som r inom <!-- --> gr att upprepa 0 eller fler ggr, om 0 s mste html-delen tas bort
	 */
	public void doGet(HttpServletRequest req, HttpServletResponse res)throws ServletException, IOException {
		Mixer mix = new Mixer(htmlDynamic);
		res.setContentType("text/html");
		PrintWriter out = res.getWriter();
		Enumeration iter = null;
		String[] values = null;
		Cookie[] cookies = null;
		String tmp = null;
		mix.add("===servlname===",  getServletName());
		iter = getInitParameterNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===initpars===-->", "===initparname===", tmp);
				mix.add("<!--===initpars===-->", "===initpar===", getInitParameter(tmp));
			}
		}else{
			mix.removeHTML("<!--===initpars===-->");	
		}
		iter = getServletContext().getInitParameterNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===continitpars===-->", "===continitparname===", tmp);
				mix.add("<!--===continitpars===-->", "===continitpar===", getServletContext().getInitParameter(tmp));
			}
		}else{
			mix.removeHTML("<!--===continitpars===-->");	
		}
		mix.add("===servname===",  req.getServerName());
		mix.add("===servport===",  "" + req.getServerPort());
		mix.add("===servinfo===",  getServletContext().getServerInfo());
		iter = getServletContext().getAttributeNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===servattribs===-->", "===servattribname===", tmp);
				mix.add("<!--===servattribs===-->", "===servattrib===", "" + getServletContext().getAttribute(tmp));
			}
		}else{
			mix.removeHTML("<!--===servattribs===-->");	
		}
		mix.add("===majver===", "" + getServletContext().getMajorVersion());
		mix.add("===minver===", "" + getServletContext().getMinorVersion());
		mix.add("===jdkver===", System.getProperty("java.version"));
		mix.add("===remaddr===", req.getRemoteAddr());
		mix.add("===remhost===",  req.getRemoteHost());
		mix.add("===remuser===",  req.getRemoteUser());
		mix.add("===authtype===",  req.getAuthType());
		iter = req.getHeaderNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===heads===-->", "===headname===", tmp);
				mix.add("<!--===heads===-->", "===head===", "" + req.getHeader(tmp));
			}
		}else{
			mix.removeHTML("<!--===servattribs===-->");	
		}
		mix.add("===querstr===", "" + req.getQueryString());
		mix.add("===charenc===", "" + req.getCharacterEncoding());
		mix.add("===contlength===", Integer.toString(req.getContentLength()));
		mix.add("===conttype===", req.getContentType());
		iter = req.getParameterNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===reqpars===-->", "===reqpar===", tmp);
				values = req.getParameterValues(tmp);
				for(int i = 0; i < values.length; i++){
					mix.add("<!--===reqpars===-->", "===reqvalname===", "Value nr" + i+1);
					mix.add("<!--===reqpars===-->", "===reqvalpar===", "" + values[i]);
				}
			}
		}else{
			mix.removeHTML("<!--===reqpars===-->");	
		}
		cookies = req.getCookies();
		if (cookies != null){
			for(int i = 0; i < cookies.length; i++){
				mix.add("<!--===coocies===-->", "===coocyname===", "" + cookies[i].getName());
				mix.add("<!--===coocies===-->", "===coocpar===", "" + cookies[i].getValue());
			}
		}else{
			mix.removeHTML("<!--===coocies===-->");	
		}
		mix.add("===pathinfo===", "" + req.getPathInfo());
		mix.add("===translpath===", "" + req.getPathTranslated());
		mix.add("===requri===", req.getRequestURI());
		mix.add("===requrl===", "" + req.getRequestURL());
		mix.add("===reqsch===",  req.getScheme());
		mix.add("===contpath===",  req.getContextPath());
		mix.add("===servpath===",  req.getServletPath());
		mix.add("===reqprot===",  req.getProtocol());
		mix.add("===reqmeth===",  req.getMethod());
		iter = req.getAttributeNames();
		if (iter.hasMoreElements()){
			while (iter.hasMoreElements()){
				tmp = (String)iter.nextElement();
				mix.add("<!--===reqattribs===-->", "===reqattribname===", tmp);
				mix.add("<!--===reqattribs===-->", "===reqattrib===", "" + req.getAttribute(tmp));
			}
		}else{
			mix.removeHTML("<!--===reqattribs===-->");	
		}
		out.println(mix.getMix());
	}
}