import java.io.*;
import mixer.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.oreilly.servlet.MultipartRequest;
public class guestBookImage extends HttpServlet{

	Connection con = null;
	String htmlDynamic = null;
	PreparedStatement pstmt1 = null;
	PreparedStatement pstmt2 = null;
	PreparedStatement pstmt3 = null;
	Mixer mix = null;
	
	/*Kopplar till databasen geustbookimage, skapar 3 st prepared statements och stter autocommit till false
	fr att mljiggra transaktionshantering
	*/
	public void init() throws ServletException{
		try{
			String url = "jdbc:mysql://localhost/guestbookimage";
			Class.forName("com.mysql.jdbc.Driver");
			con = DriverManager.getConnection(url, "josef", "cotaidis");
			con.setAutoCommit(false);
			pstmt1 = con.prepareStatement("INSERT INTO message (datim, name, email, homepage, comment)  values (now(), ?, ?, ?, ?)");
			pstmt2 = con.prepareStatement("SELECT * FROM message;");
			pstmt3 = con.prepareStatement("INSERT INTO image (id, pic, mime) values (LAST_INSERT_ID(), ?, ?)");
		}catch(ClassNotFoundException cnfe){
			log("Couldn't load database driver: " + cnfe.getMessage());
		}catch(SQLException sqle){
			log("SQLException caught: " + sqle.getMessage());
		}
	}
	
	//Kopplar frn databasen
	public void destroy(){
		try{
			con.close();
		}catch(SQLException sqle){
			log("SQLException caught: " + sqle.getMessage());
		}
	}
	
	//Skriver ut hela innehllet i databasen
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException{
		res.setContentType("text/html");
		PrintWriter out = res.getWriter();
		if (htmlDynamic == null) {
			htmlDynamic = Mixer.getContent(new File(getServletContext().getRealPath("guestbookimage.html")));
		}
		mix = new Mixer(htmlDynamic);
		try{
			Boolean flag = true;
			ResultSet rs = pstmt2.executeQuery();
			if(rs.first()){
				while(flag){
					mix.add("<!--===messages===-->", "===id===", rs.getString("id"));
					mix.add("<!--===messages===-->", "===datim===", rs.getString("datim"));
					mix.add("<!--===messages===-->", "===email===", rs.getString("email"));
					mix.add("<!--===messages===-->", "===homepage===", rs.getString("homepage"));
					mix.add("<!--===messages===-->", "===name===", rs.getString("name"));
					mix.add("<!--===messages===-->", "===comment===", rs.getString("comment"));
					mix.add("<!--===messages===-->", "===imagesrc===", "http://localhost:8080/ip/servlet/getImage?id=" +rs.getString("id"));
					flag = rs.next();
				}
				rs.close();
			}else{
				mix.removeHTML("<!--===messages===-->");
			}
		}catch(SQLException sqle){
			log("SQLException caught: " + sqle.getMessage());
		}
		out.println(mix.getMix());
	}
	
	/*Skapar en multipartRequest
	tar fram skvgen fr serverns temporra katalog dr bilden sparas innan den lagras i databasen
	lser in bilden till bytearrayen data
	utfr en transaktion dr data sparas i tv olika tabeller i rtt ordning
	utfr commit fr att slppa lset till databasen
	om fel intrffar utfrs en rollback
	slutligen anropas doGet fr att visa det uppdaterade innehllet
	*/
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException{
		
		try{
			File dir = (File)getServletContext().getAttribute("javax.servlet.context.tempdir");
			MultipartRequest multi = new MultipartRequest(req, dir.getAbsolutePath(), 5 * 1024 * 1024);
			File f = multi.getFile("image");
			byte[] data = null;
			if (f != null){
				FileInputStream fis = new FileInputStream(f);
				data=new byte[(int) f.length()];
				fis.read(data);
				fis.close();
			}
			if(multi.getParameter("name") != null){
				pstmt1.setString(1, multi.getParameter("name").replaceAll("<", "&lt;").replaceAll(">", "&gt;"));
				pstmt1.setString(2, multi.getParameter("email").replaceAll("<", "&lt;").replaceAll(">", "&gt;"));
				pstmt1.setString(3, multi.getParameter("homepage").replaceAll("<", "&lt;").replaceAll(">", "&gt;"));
				pstmt1.setString(4, multi.getParameter("comment").replaceAll("<", "&lt;").replaceAll(">", "&gt;"));
				pstmt1.executeUpdate();
				if (data != null){
					pstmt3.setBytes(1, data);
					pstmt3.setString(2, multi.getContentType("image"));
					pstmt3.executeUpdate();
				}
			}
			con.commit();
		}catch(SQLException sqle){
			log(sqle.getMessage());
			try{
				con.rollback();
			}catch(SQLException sqlex){}
		}catch(Exception e){
			log(e.getMessage());
		}
		doGet(req, res);
	}
}